<?php

function linkWiki( $cat, $place ) {

	global $currentuser,$allow_admin;
	//
	// $cat is the Wiki Category that will be used for the link to the wiki site
	// 		If $cat is "Places" then $place must be a place name
	//			If there is a GenWiki article for the place 
	//				then the function returns the original place name as a link to the GenWiki article
	//			Otherwise, the original place name is returned and, if the administrator is logged in, the
	//				place name is followed by a dimmed document icon which can be used to generate a wiki article
	//		If $cat is NOT "Places" then $place is assumed to be a person name
	//			If there is a GenWiki article for the person
	//				then a document icon is returned that is linked to the GenWiki article
	//			Otherswise, if the administrator is logged in, a dimmed document icon is return which can be used
	//				to gnerate a wiki article for the person
	//
	// The following variables must be specified for your specific server and wiki setup
	// 	$wiki_admin_name and $wiki_admin_pwd are the name and password used to access your TNG database
	//	$wiki_url is the URL of your GenWiki index.php page.
	//	$wiki_db is the name of your TNG database (Your wiki tables must be installed in your TNG database.)

	$wiki_host_name = "localhost";
	$wiki_admin_name = "xxxxx";
	$wiki_admin_pwd = "xxxxxxx";
	$wiki_url = "xxxxxxxxxxxxx";
	$wiki_db = "xxxxxxxxxxxx";
	
	// The following option must be selected based upon the URL path type used in your wiki Installation
	// Check you LocalSettings.php file in the base directory, the option $wgArticlePath will define the
	// choice here
	//
	// $wiki_url_type = "/";
	$wiki_url_type = "?title=";

	$retstr = "";			
	
	if(mysql_select_db("$wiki_db")) {

		if($cat == "Places") {
			$retstr = $place;
			$placestr = parsePlaceName( $place );
			$neatName = ereg_replace("_"," ",$placestr);
			$dbw_query = "SELECT page_title FROM page WHERE page_title=\"$placestr\"";
			$therows = mysql_query($dbw_query);
			if(mysql_num_rows($therows) > 0 ) {
				$retstr = "<a title=\"Additional Information on $neatName\" href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $placestr . "\">" . $place . "</a>";
			} else {
				if($allow_admin) {
					$retstr .= "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $placestr . "\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $neatName\"/></a>";
				}
			}	
		} else {
			$placestr = trim($place);							// remove spaces and junk from the ends
			$placestr = ereg_replace(" ","_",$placestr);		// replace spaces with underscore
			if( $placestr != "") {
				$dbw_query = "SELECT page_title FROM page WHERE page_title=\"$placestr\"";
				$therows = mysql_query($dbw_query);
				if($therows){
					if(mysql_num_rows($therows) > 0) {
						$retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $placestr . "\"><img src=\"doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Additional Information on $place\"/></a>";
					} else {
						if($allow_admin || ($currentuser == "TNGuser")) {
							$retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $placestr . "\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $place\"/></a>";
						}
					}
				} else {
					if($allow_admin) {
						$retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $placestr . "\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $place\"/></a>";
					}
				}
			}
		}
		if($therows) mysql_free_result($therows);
	}
	return $retstr;
}


// This following function is called to translate the place name as found in the TNG
// database into a place name that is to be used for an article in the wiki database.
// The function should be altered, if needed, to match local requirements.
//
// The following version attempts to do the following:
// Given that a place name may have four elements, separated by commas:
//    city, county(or parish), state, country; there are 16 possibilities:
//
//  Case#   City  County  State  Country     produces
//  -----   ----  ------  -----  -------     -------------------------------------
//    0      N      N       N      N         "" - empty string
//    1      N      N       N      Y         Country
//    2      N      N       Y      N         State
//    3      N      N       Y      Y         State [, Country] - country added if not USA or Canada
//    4      N      Y       N      N         xxxx County
//    5      N      Y       N      Y         xxxx County [, Country] - country added if not USA or Canada
//    6      N      Y       Y      N         xxxx County, State
//    7      N      Y       Y      Y         xxxx County, State
//    8      Y      N       N      N         City (or whatever the 1st parm is)
//    9      Y      N       N      Y         City [, Country] - country added if not USA or Canada
//    10     Y      N       Y      N         City, State
//    11     Y      N       Y      Y         City, State
//    12     Y      Y       N      N         City, xxxx County
//    13     Y      Y       N      Y         City, xxxx County
//    14     Y      Y       Y      N         City, State
//    15     Y      Y       Y      Y         City, State
//
//   If City ends with "Township" the "Township is removed"
//   If City begins with "near" the word "near" is removed
//   If County does not contain "County" or "Parish", " County" is appended to it
//   Countries named "USA" "United States" or "Canada" are ignored
//      (unless country is one of only 1 or 2 parms presented
function parsePlaceName( $place ) {

	list($city, $county, $state, $country) = explode(",", $place);

	// Remove words from the City Parameter
	$city = ereg_replace("Township$","",$city);
	$city = ereg_replace("^near","",$city);
	$city = trim($city);

	$county = trim($county);
	$state = trim($state);
	$country = trim($country);
	

	// Calculate the case number
	$caseNum = 0;
	if ($country != "") $caseNum += 1;
	if ($state != "")   $caseNum += 2;
	if ($county != "")	$caseNum += 4;
	if ($city != "")	$caseNum += 8;
	
	// Append " County" to the county name
	if ( ($caseNum > 3 && $caseNum < 8) || $caseNum == 13 ) {
		if ( stripos($county, " County") === false && strpos($county, " Parish") === false)
			$county .= " County";
	}

	// Eliminate certain countries - This could be a configurable array of names to check
	if ( $caseNum == 3 || $caseNum == 5 || $caseNum == 9 ) {
		if (stripos($country, "USA") !== false || stripos($country, "United States") !== false || stripos($country, "Canada") !== false) {
			$country = "";
			$caseNum -= 1;
		}
	}
	
	if ($caseNum > 7) {
		$word1 = $city;
	} elseif ($caseNum > 3) {
		$word1 = $county;
	} elseif ($caseNum > 1) {
		$word1 = $state;
	} else {
		$word1 = $country;
	}
	
	if ($word1 == "") {
		return "";
	}

	if ( $caseNum == 3 || $caseNum == 5 || $caseNum == 9 ) {
		$word2 = $country;
	} elseif ( $caseNum == 1 || $caseNum == 2 || $caseNum == 4 || $caseNum == 8  ) {
		$word2 = "";
	} elseif ( $caseNum == 12 || $caseNum == 13 ) {
		$word2 = $county;
	} else {
		$word2 = $state;
	}
	
	if ($word2 != "") {
		$comma = ", ";
	} else {
		$comma = "";
	}
		
	$placestr = $word1 . $comma . $word2;	
	$placestr = ereg_replace(" ","_",$placestr);
	return $placestr;		
}
?>
